// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#pragma once

#include <memory>
#include <string>

namespace verifone_sdk {

enum class ContentType;

/** Menu options offered to the Cashier. */
class MenuEntry {
public:
    virtual ~MenuEntry() {}

    /** Creates an instance of MenuEntry */
    static std::shared_ptr<MenuEntry> create();

    /** Defines if the menu item can be selected or not. */
    virtual bool isSelectable() const = 0;

    /** Sets the menu item to be selectable or not */
    virtual void setSelectable(bool selectable) = 0;

    /**
     * Defines if the menu item leads to a submenu when pressed, triggering another
     * round of User Input events if selected.
     */
    virtual bool leadsToSubmenu() const = 0;

    /**
     * Sets the menu item leads to a submenu when pressed, triggering another
     * round of User Input events if selected.
     */
    virtual void setLeadsToSubmenu(bool leadsToSubmenu) = 0;

    /** If this option is selected by default or not. */
    virtual bool isSelectedByDefault() const = 0;

    /** Sets the option to selected by default or not. */
    virtual void setSelectedByDefault(bool selectedByDefault) = 0;

    /**
     * Sets the contentType, either {@link ContentType#HTML} or
     * {@link ContentType#TEXT} (default).
     */
    virtual void setContentType(ContentType contentType) = 0;

    /**
     * The content type, either {@link ContentType#HTML} or
     * {@link ContentType#TEXT} (default).
     */
    virtual ContentType getContentType() const = 0;

    /** The content to be displayed, either text or html depending on {@link #getContentType()}. */
    virtual std::string getContent() const = 0;

    /** Sets the content to be displayed, either text or html depending on {@link #getContentType()}. */
    virtual void setContent(const std::string & content) = 0;
};

}  // namespace verifone_sdk
