// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from PresentationMethod.djinni

#pragma once

#include <functional>
#include <string>

namespace verifone_sdk {

enum class PresentationMethod : int {
    /** Magnetic Stripe / Swipe */
    MAG_STRIPE,
    /** EMV chip. */
    CHIP,
    /** Contactless card tap. */
    CTLS_CARD,
    /** Contactless card by phone */
    CTLS_PHONE,
    /** Reading the magnetic stripe but without swiping. */
    CTLS_MAG_STRIPE,
    /** The card information was keyed in using the terminal. */
    KEYED,
    /** The card was accepted offline, such as through a carbon paper copy. */
    MANUAL,
    /** RFID card tap. */
    RFID,
    /** The card was scanned in digitally */
    SCANNED,
    /** The card was from a stored card on file. */
    FILE,
    /** EMV chip, synchronously confirmed. */
    CHIP_SYNCHRONOUS,
    /** base64-encoded VAS data */
    VAS,
};

constexpr std::string_view toString(const PresentationMethod& arg) {
    switch(arg) {
        case PresentationMethod::MAG_STRIPE: return "MAG_STRIPE";
        case PresentationMethod::CHIP: return "CHIP";
        case PresentationMethod::CTLS_CARD: return "CTLS_CARD";
        case PresentationMethod::CTLS_PHONE: return "CTLS_PHONE";
        case PresentationMethod::CTLS_MAG_STRIPE: return "CTLS_MAG_STRIPE";
        case PresentationMethod::KEYED: return "KEYED";
        case PresentationMethod::MANUAL: return "MANUAL";
        case PresentationMethod::RFID: return "RFID";
        case PresentationMethod::SCANNED: return "SCANNED";
        case PresentationMethod::FILE: return "FILE";
        case PresentationMethod::CHIP_SYNCHRONOUS: return "CHIP_SYNCHRONOUS";
        case PresentationMethod::VAS: return "VAS";
        default: return "PresentationMethod enum value not supported";
    }
}

}  // namespace verifone_sdk

namespace std {

template <>
struct hash<::verifone_sdk::PresentationMethod> {
    size_t operator()(::verifone_sdk::PresentationMethod type) const {
        return std::hash<int>()(static_cast<int>(type));
    }
};

}  // namespace std
